/* ex8.c	-- Yasuhiro Yamazaki Tue Nov  6 2001
 */
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "pngtexture.h"

/* ɥξ֤򼨤 */
#define WINDOW_STATE_SHOW 0
#define WINDOW_STATE_HIDE 1

/* ɽåɿ */
#define GRID        6

/* ľʬǽ */
#define DIVIDE_GRID 20

/* ȥݥȤΥ */
#define CONTROL_POINT_WIDTH  4
#define CONTROL_POINT_HEIGHT 4

/* ž ɥʬɥåȤɤž뤫򼨤 */
#define ROTATION_COEFFICIENT 180.0 /* degree */

/* Static ѿ */
static int window_state = WINDOW_STATE_SHOW;    /* ɥξ */
static double ratio_x = 0.0, ratio_y = 0.0;    /* ޥɸη׻ݻ */
static float rotate_x = 0.0f, rotate_y = 0.0f; /* ɽǥβž */
static int push_button;                        /* 줿ܥݻ */

/* ٥̤Υȥݥ */
static GLfloat control_points[CONTROL_POINT_HEIGHT][CONTROL_POINT_WIDTH][3] = {
  { {-1.0, -1.0, -0.3}, {-0.3, -1.0, 0.0}, {0.3, -1.0, 0.0}, {1.0, -1.0, -0.3} },
  { {-1.0, -0.3,  0.0}, {-0.3, -0.3, 0.6}, {0.3, -0.3, 0.6}, {1.0, -0.3,  0.0} },
  { {-1.0,  0.3,  0.0}, {-0.3,  0.3, 0.6}, {0.3,  0.3, 0.6}, {1.0,  0.3,  0.0} },
  { {-1.0,  1.0, -0.3}, {-0.3,  1.0, 0.0}, {0.3,  1.0, 0.0}, {1.0,  1.0, -0.3} }
};

/*  */
static void
initializeAll( void )
{
  /* Х奨 */
  glMap2f( GL_MAP2_VERTEX_3, 
	   0.0, 1.0f,  3, 4, 
	   0.0, 1.0f, 12, 4,
	   (GLfloat *)control_points );
  glEnable(GL_MAP2_VERTEX_3);
  glMapGrid2f( 10, 0.0f, 1.0f, 10, 0.0f, 1.0f );


  /* Ƥ٤ΤФ */

}

/*  */
static void
freeAll( void )
{
  /* νϤ */
}

/* 饤Ȥλ */
static void
putLight( void )
{
  /* 饤ȤλϤ */
}

/* ʪΤɽ */
static void 
putSomething( void )
{
  int i, j;



  /* ̾˥åɤ */
  glColor3f( 0.0f, 0.0f, 1.0f );
  for( i=0; i<=GRID; i++ ){
    glBegin( GL_LINE_STRIP );
    for( j=0; j<=DIVIDE_GRID; j++ ){
      glEvalCoord2f( (GLfloat)i/(GLfloat)GRID, 
		     (GLfloat)j/(GLfloat)DIVIDE_GRID);
    }
    glEnd();
    glBegin( GL_LINE_STRIP );
    for( j=0; j<=DIVIDE_GRID; j++ ){
      glEvalCoord2f( (GLfloat)j/(GLfloat)DIVIDE_GRID,
		     (GLfloat)i/(GLfloat)GRID );
    }
    glEnd();
  }

  /* ֤ʬ */
  glColor3f( 0.0f, 1.0f, 0.0f );
  for( i=0; i<CONTROL_POINT_HEIGHT; i++ ){
    glBegin( GL_LINE_STRIP );
    for( j=0; j<CONTROL_POINT_WIDTH; j++ ){
      glVertex3fv( (GLfloat *)control_points[i][j] );
    }
    glEnd();
  }
  for( i=0; i<CONTROL_POINT_WIDTH; i++ ){
    glBegin( GL_LINE_STRIP );
    for( j=0; j<CONTROL_POINT_HEIGHT; j++ ){
      glVertex3fv( (GLfloat *)control_points[j][i] );
    }
    glEnd();
  }

  /*  */
  glPointSize( 5.0 );
  glColor3f( 1.0f, 0.0f, 0.0f );
  glBegin( GL_POINTS );
  for( i=0; i<CONTROL_POINT_HEIGHT; i++ ){
    for( j=0; j<CONTROL_POINT_WIDTH; j++ ){
      glVertex3fv( control_points[i][j] );
    }
  }
  glEnd();

}

/* 褬ɬפȤʤä˸ƤФ */
static void
displayCallback( void )
{
  glLoadIdentity();

  /*  */
  gluLookAt( 0.0, 0.0, 2.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 );

  /* ХåեΥꥢ */
  glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT );

  glPushMatrix();
    /* Put light */
    putLight();
    
    /* Rotation */
    glRotatef( rotate_y, 0.0f, 1.0f, 0.0f);
    glRotatef( rotate_x, 1.0f, 0.0f, 0.0f);

    /* Put something */
    putSomething();
  glPopMatrix();

  /* ХåեΥå */
  glutSwapBuffers();
}

/* ɥꥵ줿˸ƤФ */
static void
reshapeCallback( int width, int height )
{
  glViewport( 0, 0, width, height );

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 60.0, width/(GLdouble)height, 0.01, 100 );

  glMatrixMode( GL_MODELVIEW );
}

/* ɥϾƤФ */
static void
idleCallback( void )
{
  if( window_state==WINDOW_STATE_SHOW ){
    /* ɥ˹Ԥ򤳤˵ */
    
    /* ɬפС򤹤 */
    /* glutPostRedisplay(); */
  }
}

/* ɥ{ɽ/줿}˸ƤФ */
static void
visibilityCallback( int state )
{
  switch( state ){
  case GLUT_NOT_VISIBLE:
    fprintf( stderr, "THE WINDOW WAS HIDDEN.\n" );
    window_state = WINDOW_STATE_HIDE;
    break;
  case GLUT_VISIBLE:
    fprintf( stderr, "THE WINDOW WAS SHOWN.\n" );
    window_state = WINDOW_STATE_SHOW;
    break;
  }
}

/* ޥɸΥɥФ׻ */
static void
calculationRatioOfMouseCoordinate( const int x, const int y )
{
  int width, height;
  width  = glutGet( GLUT_WINDOW_WIDTH );
  height = glutGet( GLUT_WINDOW_HEIGHT );
  ratio_x = (double)y/(double)height;
  ratio_y = (double)x/(double)width;
}

/* ޥΥܥѲä˸ƤФ */
static void
mouseCallback( int button, int state, int x, int y )
{
  switch( button ){
  case GLUT_LEFT_BUTTON:
    push_button = GLUT_LEFT_BUTTON;
    /*    fprintf( stderr, "LEFT BUTTON: " );*/
    break;
  case GLUT_MIDDLE_BUTTON:
    push_button = GLUT_MIDDLE_BUTTON;
    /*    fprintf( stderr, "MIDDLE BUTTON: " );*/
    break;
  case GLUT_RIGHT_BUTTON:
    push_button = GLUT_RIGHT_BUTTON;
    /*    fprintf( stderr, "RIGHT BUTTON: " );*/
    break;
  }
  
  switch( state ){
  case GLUT_DOWN:
    /*    fprintf( stderr, "DOWN\n" );*/
    break;
  case GLUT_UP:
    /*    fprintf( stderr, "UP\n" );*/
    break;
  }

  calculationRatioOfMouseCoordinate( x, y );
}

/* ޥΥݥ󥿤ưä˸ƤФ */
static void
passiveMotionCallback( int x, int y )
{
  /*  fprintf( stderr, "MOUSE (%d, %d)\n", x, y );*/
}

/* ɥå桢ޥΥݥ󥿤ưä˸ƤФ */
static void
motionCallback( int x, int y )
{
  double rx, ry;

  fprintf( stderr, "DRAG (%d, %d) ", x, y );

  switch( push_button ){ /* Ƥܥ˱ȿ򤵤 */
  case GLUT_LEFT_BUTTON:
    /*    fprintf( stderr, "LEFT BUTTON\n" );*/
    /* ʪΤβž׻ */
    rx = ratio_x;
    ry = ratio_y;
    calculationRatioOfMouseCoordinate( x, y );
    rotate_x += (float)((ratio_x-rx)*ROTATION_COEFFICIENT);
    rotate_y += (float)((ratio_y-ry)*ROTATION_COEFFICIENT);
    glutPostRedisplay();
    break;
  case GLUT_MIDDLE_BUTTON:
    /*    fprintf( stderr, "MIDDLE BUTTON\n" );*/
    break;
  case GLUT_RIGHT_BUTTON:
    /*    fprintf( stderr, "RIGHT BUTTON\n" );*/
    break;
  }
}

/* Ϥä˸ƤФ */
static void
keyboardCallback( unsigned char key, int x, int y )
{
  fprintf( stderr, "HIT \'%c\' KEY (CODE: %d)\n", (key<32)?'?':key, (int)key );

  switch( key ){
  /*
  ** Esc줿ץλ
  */
  case 27:
    exit( EXIT_SUCCESS );
    break;

  default:
    break;
  }
}

/* OpenGL ν */
static void
initGL( void )
{
  int width, height;

  width  = glutGet( GLUT_WINDOW_WIDTH );
  height = glutGet( GLUT_WINDOW_HEIGHT );

  reshapeCallback( width, height );

  glClearColor( 0.0, 0.0, 0.0, 0.0 );
  glEnable( GL_DEPTH_TEST );
  glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
}

/* MAIN */
int
main( int argc, char *argv[] )
{
  glutInit( &argc, argv );
  glutInitDisplayMode( GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH );

  glutCreateWindow( "ex7 BLEND ANIMATION" );

  glutDisplayFunc      ( displayCallback       );
  glutKeyboardFunc     ( keyboardCallback      );
  glutReshapeFunc      ( reshapeCallback       );
  glutIdleFunc         ( idleCallback          );
  glutVisibilityFunc   ( visibilityCallback    );
  glutMouseFunc        ( mouseCallback         );
  glutPassiveMotionFunc( passiveMotionCallback );
  glutMotionFunc       ( motionCallback        );
  
  initGL(); /* OpenGL ν */
  initializeAll(); /*  */
  
  glutMainLoop(); /* ᥤ롼פγ */

  freeAll(); /*  */
  
  return EXIT_SUCCESS;
}
